Overview | Package | Class | Use | Tree | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.index
Class MultiDocsAndPositionsEnum

    java.lang.Object
      org.apache.lucene.search.DocIdSetIterator
          org.apache.lucene.index.DocsEnum
              org.apache.lucene.index.DocsAndPositionsEnum
                  org.apache.lucene.index.MultiDocsAndPositionsEnum

    public final class MultiDocsAndPositionsEnum

extends DocsAndPositionsEnum

Exposes flex API, merged from flex API of sub-segments.

WARNING: This API is experimental and might change in incompatible ways in the next release.

Nested Class Summary
`static class` | `MultiDocsAndPositionsEnum.EnumWithSlice` Holds a `DocsAndPositionsEnum` along with the corresponding `ReaderSlice`.

Field Summary

Fields inherited from class org.apache.lucene.index.DocsAndPositionsEnum
`FLAG_OFFSETS, FLAG_PAYLOADS`

Fields inherited from class org.apache.lucene.index.DocsEnum
`FLAG_FREQS, FLAG_NONE`

Fields inherited from class org.apache.lucene.search.DocIdSetIterator
`NO_MORE_DOCS`

Constructor Summary
`MultiDocsAndPositionsEnum(MultiTermsEnum parent, int subReaderCount)` Sole constructor.

Method Summary
`int` | `advance(int target)` Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself.
`boolean` | `canReuse(MultiTermsEnum parent)` Returns `true` if this instance can be reused by the provided `MultiTermsEnum`.
`long` | `cost()` Returns the estimated cost of this `DocIdSetIterator`.
`int` | `docID()` Returns the following: -1 or `DocIdSetIterator.NO_MORE_DOCS` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
`int` | `endOffset()` Returns end offset for the current position, or -1 if offsets were not indexed.
`int` | `freq()` Returns term frequency in the current document, or 1 if the field was indexed with `FieldInfo.IndexOptions.DOCS_ONLY`.
`int` | `getNumSubs()` How many sub-readers we are merging.
`BytesRef` | `getPayload()` Returns the payload at this position, or null if no payload was indexed.
`MultiDocsAndPositionsEnum.EnumWithSlice[]` | `getSubs()` Returns sub-readers we are merging.
`int` | `nextDoc()` Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set. NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
`int` | `nextPosition()` Returns the next position.
`MultiDocsAndPositionsEnum` | `reset(MultiDocsAndPositionsEnum.EnumWithSlice[] subs, int numSubs)` Rre-use and reset this instance on the provided slices.
`int` | `startOffset()` Returns start offset for the current position, or -1 if offsets were not indexed.
`String` | `toString()`

Methods inherited from class org.apache.lucene.index.DocsEnum
`attributes`

Methods inherited from class org.apache.lucene.search.DocIdSetIterator
`slowAdvance`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### MultiDocsAndPositionsEnum

    public MultiDocsAndPositionsEnum(MultiTermsEnum parent,
                                     int subReaderCount)

  Sole constructor.

Method Detail

### canReuse

    public boolean canReuse(MultiTermsEnum parent)

  Returns `true` if this instance can be reused by the provided `MultiTermsEnum`.

### reset

    public MultiDocsAndPositionsEnum reset(MultiDocsAndPositionsEnum.EnumWithSlice[] subs,
                                           int numSubs)

  Rre-use and reset this instance on the provided slices.

### getNumSubs

    public int getNumSubs()

  How many sub-readers we are merging.

  See Also:
    `getSubs()`

### getSubs

    public MultiDocsAndPositionsEnum.EnumWithSlice[] getSubs()

  Returns sub-readers we are merging.

### freq

    public int freq()
             throws IOException

  Description copied from class: `DocsEnum`
  Returns term frequency in the current document, or 1 if the field was indexed with `FieldInfo.IndexOptions.DOCS_ONLY`. Do not call this before `DocIdSetIterator.nextDoc()` is first called, nor after `DocIdSetIterator.nextDoc()` returns `DocIdSetIterator.NO_MORE_DOCS`.

  NOTE: if the `DocsEnum` was obtain with `DocsEnum.FLAG_NONE`, the result of this method is undefined.

  Specified by:
    `freq` in class `DocsEnum`
  Throws:
    `IOException`

### docID

    public int docID()

  Description copied from class: `DocIdSetIterator`
  Returns the following:
  - -1 or `DocIdSetIterator.NO_MORE_DOCS` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
  - `DocIdSetIterator.NO_MORE_DOCS` if the iterator has exhausted.
  - Otherwise it should return the doc ID it is currently on.

  Specified by:
    `docID` in class `DocIdSetIterator`

### advance

    public int advance(int target)
                throws IOException

  Description copied from class: `DocIdSetIterator`
  Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself. Exhausts the iterator and returns `DocIdSetIterator.NO_MORE_DOCS` if target is greater than the highest document number in the set.

  The behavior of this method is undefined when called with `target ≤ current`, or after the iterator has exhausted. Both cases may result in unpredicted behavior.

  When `target > current` it behaves as if written:

       int advance(int target) {
         int doc;
         while ((doc = nextDoc()) < target) {
         }
         return doc;
       }

  Some implementations are considerably more efficient than that.

  NOTE: this method may be called with `DocIdSetIterator.NO_MORE_DOCS` for efficiency by some Scorers. If your implementation cannot efficiently determine that it should exhaust, it is recommended that you check for that value in each call to this method.

  Specified by:
    `advance` in class `DocIdSetIterator`
  Throws:
    `IOException`

### nextDoc

    public int nextDoc()
                throws IOException

  Description copied from class: `DocIdSetIterator`
  Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.
  NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.

  Specified by:
    `nextDoc` in class `DocIdSetIterator`
  Throws:
    `IOException`

### nextPosition

    public int nextPosition()
                     throws IOException

  Description copied from class: `DocsAndPositionsEnum`
  Returns the next position. You should only call this up to `DocsEnum.freq()` times else the behavior is not defined. If positions were not indexed this will return -1; this only happens if offsets were indexed and you passed needsOffset=true when pulling the enum.

  Specified by:
    `nextPosition` in class `DocsAndPositionsEnum`
  Throws:
    `IOException`

### startOffset

    public int startOffset()
                    throws IOException

  Description copied from class: `DocsAndPositionsEnum`
  Returns start offset for the current position, or -1 if offsets were not indexed.

  Specified by:
    `startOffset` in class `DocsAndPositionsEnum`
  Throws:
    `IOException`

### endOffset

    public int endOffset()
                  throws IOException

  Description copied from class: `DocsAndPositionsEnum`
  Returns end offset for the current position, or -1 if offsets were not indexed.

  Specified by:
    `endOffset` in class `DocsAndPositionsEnum`
  Throws:
    `IOException`

### getPayload

    public BytesRef getPayload()
                        throws IOException

  Description copied from class: `DocsAndPositionsEnum`
  Returns the payload at this position, or null if no payload was indexed. You should not modify anything (neither members of the returned BytesRef nor bytes in the byte[]).

  Specified by:
    `getPayload` in class `DocsAndPositionsEnum`
  Throws:
    `IOException`

### cost

    public long cost()

  Description copied from class: `DocIdSetIterator`
  Returns the estimated cost of this `DocIdSetIterator`.

  This is generally an upper bound of the number of documents this iterator might match, but may be a rough heuristic, hardcoded value, or otherwise completely inaccurate.

  Specified by:
    `cost` in class `DocIdSetIterator`

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Use | Tree | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2013 Apache Software Foundation. All Rights Reserved.